/* 256^2 (value) * 10000 (width) * 10000 (height) * 100 (fps) * 3600 * 5 =
   2^63.35 */
typedef unsigned long long statistic_int_t;

/* psnr.c */

typedef struct {
    statistic_int_t t, n;
} vq_psnr_t;

extern void vq_psnr_init(vq_psnr_t *);
extern void vq_psnr_feed(vq_psnr_t *, const unsigned char *,
    const unsigned char *, unsigned);
extern void vq_psnr_print(const vq_psnr_t *, const char *);
extern void vq_psnr_add(vq_psnr_t *, unsigned, const vq_psnr_t *, unsigned);

/* correl.c */

typedef struct {
    statistic_int_t x, y, xx, yy, xy, n;
} vq_correl_t;

extern void vq_correl_init(vq_correl_t *);
extern void vq_correl_feed(vq_correl_t *, const unsigned char *,
    const unsigned char *, unsigned);
extern void vq_correl_print(const vq_correl_t *, const char *);
extern void vq_correl_add(vq_correl_t *, unsigned, const vq_correl_t *,
    unsigned);
